/* $Id: Scanner.c,v 2.16 1992/08/18 09:05:32 grosch rel $ */

# define bool		char
# define true		1
# define false		0
# define StdIn		0
 
# include "Scanner.h"
# include "Source.h"
# include "System.h"
# include "General.h"
# include "DynArray.h"
# include "Positions.h"
# include <stdio.h>
 
# if defined __STDC__ | defined __cplusplus
#  include <stdlib.h>
# else
/* extern char * malloc ();
   extern void free (); */
# endif

# define yyTabSpace	8

# define yyStart(State)	{ yyPreviousStart = yyStartState; yyStartState = State; }
# define yyPrevious	{ yyStateRange s = yyStartState; \
	 		yyStartState = yyPreviousStart; yyPreviousStart = s; }
# define yyEcho		{ char * yyEnd = TokenPtr + TokenLength; \
			char yyCh = * yyEnd; * yyEnd = '\0'; \
	 		(void) fputs (TokenPtr, stdout); * yyEnd = yyCh; }
# define yyLess(n)	{ yyChBufferIndex -= TokenLength - n; TokenLength = n; }
# define yyTab		yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart - 1) % yyTabSpace
# define yyTab1(a)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyTab2(a,b)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyEol(Column)	{ yyLineCount ++; yyLineStart = yyChBufferIndex - 1 - Column; }
# define output(c)	(void) putchar ((int) c)
# define unput(c)	* (-- yyChBufferIndex) = c

# define yyDNoState		0
# define yyFileStackSize	16
# define yyInitBufferSize	1024 * 8 + 256
# define yyFirstCh	(unsigned char) '\0'
# define yyLastCh	(unsigned char) '\177'
# define yyEolCh	(unsigned char) '\12'
# define yyEobCh	(unsigned char) '\177'
# define yyDStateCount	424
# define yyTableSize	2656
# define yyEobState	279
# define yyDefaultState	280
# define STD	1
# define QUOTE	3
# define AQUOTE	5
 
static void yyExit () { Exit (1); }

typedef unsigned short	yyStateRange;
typedef struct { yyStateRange yyCheck, yyNext; } yyCombType;
 
	char *		TokenPtr	;
	short		TokenLength	;
	tScanAttribute	Attribute	;
	void		(* Scanner_Exit) () = yyExit;
 
static	yyCombType	yyComb		[yyTableSize   + 1] = {{1, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{1, 282},
{1, 281},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{1, 283},
{1, 393},
{1, 140},
{12, 140},
{142, 138},
{11, 151},
{1, 383},
{1, 139},
{1, 412},
{1, 395},
{1, 387},
{1, 384},
{1, 417},
{1, 9},
{1, 415},
{1, 380},
{1, 7},
{1, 7},
{1, 7},
{1, 7},
{1, 7},
{1, 7},
{1, 7},
{1, 7},
{1, 7},
{1, 7},
{1, 356},
{1, 416},
{1, 338},
{1, 382},
{1, 377},
{9, 10},
{136, 58},
{1, 152},
{1, 175},
{1, 167},
{1, 277},
{1, 169},
{1, 314},
{1, 215},
{1, 276},
{1, 237},
{1, 276},
{1, 276},
{1, 168},
{1, 294},
{1, 185},
{1, 121},
{1, 233},
{1, 276},
{1, 125},
{1, 216},
{1, 115},
{1, 94},
{1, 211},
{1, 114},
{1, 124},
{1, 276},
{1, 276},
{8, 85},
{132, 132},
{133, 133},
{134, 134},
{143, 20},
{142, 146},
{1, 152},
{1, 175},
{1, 167},
{1, 277},
{1, 169},
{1, 314},
{1, 215},
{1, 276},
{1, 237},
{1, 276},
{1, 276},
{1, 168},
{1, 294},
{1, 185},
{1, 121},
{1, 233},
{1, 276},
{1, 125},
{1, 216},
{1, 115},
{1, 94},
{1, 211},
{1, 114},
{1, 124},
{1, 276},
{1, 276},
{8, 85},
{1, 394},
{3, 282},
{3, 281},
{11, 279},
{12, 279},
{245, 135},
{253, 232},
{255, 246},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{55, 55},
{268, 266},
{276, 256},
{278, 279},
{9, 279},
{356, 357},
{141, 21},
{3, 283},
{3, 393},
{3, 140},
{377, 378},
{136, 279},
{143, 145},
{3, 383},
{3, 424},
{3, 412},
{3, 395},
{3, 387},
{3, 384},
{3, 417},
{3, 9},
{3, 415},
{3, 380},
{3, 7},
{3, 7},
{3, 7},
{3, 7},
{3, 7},
{3, 7},
{3, 7},
{3, 7},
{3, 7},
{3, 7},
{3, 356},
{3, 416},
{3, 338},
{3, 382},
{3, 377},
{55, 149},
{60, 36},
{3, 152},
{3, 175},
{3, 167},
{3, 277},
{3, 169},
{3, 314},
{3, 215},
{3, 276},
{3, 237},
{3, 276},
{3, 276},
{3, 168},
{3, 294},
{3, 185},
{3, 121},
{3, 233},
{3, 276},
{3, 125},
{3, 216},
{3, 115},
{3, 94},
{3, 211},
{3, 114},
{3, 124},
{3, 276},
{3, 276},
{61, 47},
{141, 130},
{144, 137},
{380, 381},
{55, 279},
{60, 36},
{3, 152},
{3, 175},
{3, 167},
{3, 277},
{3, 169},
{3, 314},
{3, 215},
{3, 276},
{3, 237},
{3, 276},
{3, 276},
{3, 168},
{3, 294},
{3, 185},
{3, 121},
{3, 233},
{3, 276},
{3, 125},
{3, 216},
{3, 115},
{3, 94},
{3, 211},
{3, 114},
{3, 124},
{3, 276},
{3, 276},
{61, 47},
{3, 394},
{5, 282},
{5, 281},
{338, 379},
{338, 339},
{382, 392},
{144, 147},
{387, 391},
{56, 56},
{56, 56},
{56, 56},
{56, 56},
{56, 56},
{56, 56},
{56, 56},
{56, 56},
{56, 56},
{56, 56},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{5, 283},
{5, 393},
{5, 140},
{0, 0},
{0, 0},
{0, 0},
{5, 383},
{5, 396},
{5, 412},
{5, 395},
{5, 387},
{5, 384},
{5, 417},
{5, 9},
{5, 415},
{5, 380},
{5, 7},
{5, 7},
{5, 7},
{5, 7},
{5, 7},
{5, 7},
{5, 7},
{5, 7},
{5, 7},
{5, 7},
{5, 356},
{5, 416},
{5, 338},
{5, 382},
{5, 377},
{56, 148},
{62, 54},
{5, 152},
{5, 175},
{5, 167},
{5, 277},
{5, 169},
{5, 314},
{5, 215},
{5, 276},
{5, 237},
{5, 276},
{5, 276},
{5, 168},
{5, 294},
{5, 185},
{5, 121},
{5, 233},
{5, 276},
{5, 231},
{5, 216},
{5, 115},
{5, 94},
{5, 211},
{5, 114},
{5, 124},
{5, 276},
{5, 276},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{62, 54},
{5, 152},
{5, 175},
{5, 167},
{5, 277},
{5, 169},
{5, 314},
{5, 215},
{5, 276},
{5, 237},
{5, 276},
{5, 276},
{5, 168},
{5, 294},
{5, 185},
{5, 121},
{5, 233},
{5, 276},
{5, 231},
{5, 216},
{5, 115},
{5, 94},
{5, 211},
{5, 114},
{5, 124},
{5, 276},
{5, 276},
{7, 146},
{5, 394},
{59, 59},
{59, 59},
{59, 59},
{59, 59},
{59, 59},
{59, 59},
{59, 59},
{59, 59},
{59, 59},
{59, 59},
{63, 52},
{7, 7},
{7, 7},
{7, 7},
{7, 7},
{7, 7},
{7, 7},
{7, 7},
{7, 7},
{7, 7},
{7, 7},
{7, 147},
{64, 27},
{65, 22},
{66, 17},
{67, 13},
{0, 0},
{68, 14},
{70, 16},
{69, 66},
{71, 18},
{72, 19},
{7, 134},
{69, 90},
{73, 65},
{74, 26},
{75, 64},
{76, 28},
{77, 29},
{78, 32},
{79, 35},
{80, 42},
{63, 52},
{82, 46},
{79, 60},
{83, 61},
{84, 53},
{59, 150},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{64, 27},
{65, 22},
{66, 17},
{67, 13},
{7, 131},
{68, 14},
{70, 16},
{69, 66},
{71, 18},
{72, 19},
{0, 0},
{69, 90},
{73, 65},
{74, 26},
{75, 64},
{76, 28},
{77, 29},
{78, 32},
{79, 35},
{80, 42},
{0, 0},
{82, 46},
{79, 60},
{83, 61},
{84, 53},
{0, 0},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{7, 279},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{0, 0},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{0, 0},
{85, 57},
{87, 33},
{88, 25},
{89, 72},
{0, 0},
{90, 70},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{85, 57},
{87, 33},
{88, 25},
{89, 72},
{13, 256},
{90, 70},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{13, 276},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{13, 279},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{0, 0},
{91, 62},
{93, 30},
{96, 23},
{91, 276},
{0, 0},
{97, 74},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{91, 62},
{93, 30},
{96, 23},
{91, 276},
{41, 256},
{97, 74},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{41, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{0, 0},
{94, 317},
{98, 79},
{100, 49},
{101, 45},
{0, 0},
{94, 78},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 44},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{94, 317},
{98, 79},
{100, 49},
{101, 45},
{81, 256},
{94, 78},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 44},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{81, 276},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{81, 279},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{0, 0},
{102, 81},
{103, 83},
{104, 43},
{105, 80},
{0, 0},
{106, 39},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 34},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{102, 81},
{103, 83},
{104, 43},
{105, 80},
{86, 256},
{106, 39},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 34},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{86, 276},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{86, 279},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{0, 0},
{107, 92},
{108, 31},
{109, 93},
{110, 24},
{0, 0},
{112, 41},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 38},
{92, 276},
{107, 92},
{108, 31},
{109, 93},
{110, 24},
{92, 256},
{112, 41},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 276},
{92, 38},
{92, 276},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{92, 279},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{0, 0},
{113, 100},
{118, 51},
{120, 276},
{120, 71},
{0, 0},
{123, 77},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 15},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{113, 100},
{118, 51},
{120, 276},
{120, 71},
{95, 256},
{123, 77},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 15},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{95, 276},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{95, 279},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{0, 0},
{127, 86},
{125, 180},
{128, 117},
{129, 113},
{0, 0},
{125, 119},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 50},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{127, 86},
{125, 180},
{128, 117},
{129, 113},
{99, 256},
{125, 119},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 50},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{99, 276},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{99, 279},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{0, 0},
{155, 89},
{157, 96},
{158, 101},
{159, 82},
{0, 0},
{160, 99},
{111, 276},
{111, 276},
{111, 108},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{155, 89},
{157, 96},
{158, 101},
{159, 82},
{111, 256},
{160, 99},
{111, 276},
{111, 276},
{111, 108},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{111, 276},
{114, 322},
{116, 37},
{115, 75},
{122, 276},
{111, 279},
{153, 276},
{162, 63},
{114, 69},
{114, 291},
{115, 363},
{163, 105},
{0, 0},
{115, 325},
{153, 104},
{154, 127},
{154, 276},
{122, 76},
{116, 188},
{163, 112},
{115, 122},
{124, 130},
{0, 0},
{0, 0},
{124, 145},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{165, 155},
{122, 256},
{114, 322},
{116, 37},
{115, 75},
{122, 276},
{166, 120},
{153, 276},
{162, 63},
{114, 69},
{114, 291},
{115, 363},
{163, 105},
{154, 256},
{115, 325},
{153, 104},
{154, 127},
{154, 276},
{122, 76},
{116, 188},
{163, 112},
{115, 122},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{165, 155},
{173, 84},
{124, 364},
{124, 367},
{124, 276},
{0, 0},
{166, 120},
{117, 276},
{117, 276},
{117, 276},
{117, 40},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{173, 84},
{124, 364},
{124, 367},
{124, 276},
{117, 256},
{0, 0},
{117, 276},
{117, 276},
{117, 276},
{117, 40},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{117, 276},
{119, 204},
{126, 276},
{170, 110},
{126, 111},
{117, 279},
{161, 276},
{121, 337},
{119, 129},
{171, 160},
{161, 118},
{119, 48},
{171, 276},
{174, 67},
{119, 171},
{121, 321},
{121, 276},
{121, 73},
{119, 194},
{121, 369},
{170, 256},
{121, 226},
{121, 400},
{161, 256},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{126, 256},
{0, 0},
{0, 0},
{119, 204},
{126, 276},
{170, 110},
{126, 111},
{177, 163},
{161, 276},
{121, 337},
{119, 129},
{171, 160},
{161, 118},
{119, 48},
{171, 276},
{174, 67},
{119, 171},
{121, 321},
{121, 276},
{121, 73},
{119, 194},
{121, 369},
{0, 0},
{121, 226},
{121, 400},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{0, 0},
{178, 174},
{179, 173},
{180, 8},
{177, 163},
{182, 177},
{183, 170},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{131, 7},
{131, 7},
{131, 7},
{131, 7},
{131, 7},
{131, 7},
{131, 7},
{131, 7},
{131, 7},
{131, 7},
{148, 56},
{148, 56},
{148, 56},
{148, 56},
{148, 56},
{148, 56},
{148, 56},
{148, 56},
{148, 56},
{148, 56},
{178, 174},
{179, 173},
{180, 8},
{0, 0},
{182, 177},
{183, 170},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{130, 141},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{0, 0},
{184, 157},
{189, 106},
{190, 164},
{191, 109},
{0, 0},
{192, 165},
{135, 276},
{135, 276},
{135, 212},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{184, 157},
{189, 106},
{190, 164},
{191, 109},
{131, 279},
{192, 165},
{135, 276},
{135, 276},
{135, 212},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{135, 276},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{139, 136},
{140, 140},
{140, 140},
{140, 12},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{140, 140},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{195, 159},
{196, 102},
{197, 156},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{202, 193},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{195, 159},
{196, 102},
{197, 156},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{145, 143},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{202, 193},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{146, 142},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{149, 55},
{149, 55},
{149, 55},
{149, 55},
{149, 55},
{149, 55},
{149, 55},
{149, 55},
{149, 55},
{149, 55},
{150, 59},
{150, 59},
{150, 59},
{150, 59},
{150, 59},
{150, 59},
{150, 59},
{150, 59},
{150, 59},
{150, 59},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{147, 144},
{151, 151},
{151, 151},
{0, 0},
{151, 151},
{151, 151},
{151, 11},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{151, 151},
{152, 389},
{0, 0},
{0, 0},
{187, 126},
{152, 103},
{156, 276},
{0, 0},
{172, 91},
{164, 87},
{167, 97},
{152, 333},
{168, 154},
{152, 370},
{187, 218},
{172, 276},
{198, 197},
{152, 243},
{152, 199},
{152, 239},
{168, 418},
{156, 68},
{164, 276},
{169, 98},
{167, 244},
{169, 116},
{168, 310},
{175, 130},
{0, 0},
{207, 196},
{175, 145},
{198, 95},
{172, 256},
{152, 389},
{156, 256},
{169, 189},
{187, 126},
{152, 103},
{156, 276},
{164, 256},
{172, 91},
{164, 87},
{167, 97},
{152, 333},
{168, 154},
{152, 370},
{187, 218},
{172, 276},
{198, 197},
{152, 243},
{152, 199},
{152, 239},
{168, 418},
{156, 68},
{164, 276},
{169, 98},
{167, 244},
{169, 116},
{168, 310},
{181, 158},
{186, 88},
{207, 196},
{175, 172},
{198, 95},
{193, 276},
{188, 107},
{186, 276},
{169, 189},
{181, 276},
{175, 287},
{188, 276},
{193, 123},
{175, 284},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{199, 276},
{199, 181},
{181, 256},
{200, 276},
{188, 256},
{200, 195},
{209, 191},
{0, 0},
{181, 158},
{186, 88},
{0, 0},
{175, 172},
{0, 0},
{193, 276},
{188, 107},
{186, 276},
{0, 0},
{181, 276},
{175, 287},
{188, 276},
{193, 123},
{175, 284},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{199, 276},
{199, 181},
{210, 192},
{200, 276},
{212, 186},
{200, 195},
{209, 191},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 166},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{0, 0},
{210, 192},
{214, 183},
{212, 186},
{0, 0},
{0, 0},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 166},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{176, 276},
{194, 276},
{185, 374},
{214, 183},
{203, 200},
{176, 279},
{185, 153},
{205, 222},
{194, 162},
{201, 276},
{204, 161},
{204, 276},
{0, 0},
{201, 190},
{205, 276},
{215, 213},
{185, 372},
{203, 276},
{194, 256},
{218, 209},
{219, 208},
{206, 202},
{185, 307},
{0, 0},
{201, 256},
{0, 0},
{204, 256},
{0, 0},
{0, 0},
{205, 256},
{219, 397},
{215, 236},
{203, 256},
{194, 276},
{185, 374},
{206, 276},
{203, 200},
{220, 203},
{185, 153},
{205, 222},
{194, 162},
{201, 276},
{204, 161},
{204, 276},
{211, 210},
{201, 190},
{205, 276},
{215, 213},
{185, 372},
{203, 276},
{206, 256},
{218, 209},
{219, 208},
{206, 202},
{185, 307},
{208, 276},
{213, 182},
{208, 201},
{213, 276},
{211, 276},
{217, 198},
{216, 187},
{219, 397},
{215, 236},
{221, 207},
{216, 402},
{222, 220},
{206, 276},
{223, 217},
{220, 203},
{208, 256},
{217, 276},
{224, 223},
{213, 256},
{211, 256},
{225, 214},
{211, 210},
{216, 206},
{228, 225},
{227, 128},
{0, 0},
{234, 227},
{228, 276},
{0, 0},
{235, 221},
{0, 0},
{217, 256},
{208, 276},
{213, 182},
{208, 201},
{213, 276},
{211, 276},
{217, 198},
{216, 187},
{226, 184},
{227, 276},
{221, 207},
{216, 402},
{222, 220},
{229, 178},
{223, 217},
{230, 276},
{226, 276},
{217, 276},
{224, 223},
{236, 234},
{238, 205},
{225, 214},
{229, 276},
{216, 206},
{228, 225},
{227, 128},
{230, 176},
{234, 227},
{228, 276},
{231, 179},
{235, 221},
{226, 256},
{233, 240},
{231, 119},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{226, 184},
{227, 276},
{0, 0},
{0, 0},
{239, 235},
{229, 178},
{233, 353},
{230, 276},
{226, 276},
{233, 224},
{240, 229},
{236, 234},
{238, 205},
{0, 0},
{229, 276},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{231, 179},
{0, 0},
{0, 0},
{233, 240},
{231, 119},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{239, 235},
{241, 230},
{233, 353},
{242, 245},
{246, 241},
{233, 224},
{240, 229},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 254},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{241, 230},
{0, 0},
{242, 245},
{246, 241},
{0, 0},
{247, 248},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 254},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{232, 276},
{237, 313},
{243, 238},
{244, 228},
{244, 269},
{232, 279},
{247, 248},
{248, 242},
{249, 250},
{237, 219},
{250, 247},
{251, 252},
{252, 249},
{254, 251},
{237, 413},
{257, 255},
{258, 253},
{243, 340},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{259, 257},
{260, 262},
{261, 259},
{262, 258},
{263, 267},
{237, 313},
{243, 238},
{244, 228},
{244, 269},
{0, 0},
{0, 0},
{248, 242},
{249, 250},
{237, 219},
{250, 247},
{251, 252},
{252, 249},
{254, 251},
{237, 413},
{257, 255},
{258, 253},
{243, 340},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{259, 257},
{260, 262},
{261, 259},
{262, 258},
{263, 267},
{264, 260},
{265, 261},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{266, 265},
{267, 264},
{0, 0},
{270, 271},
{264, 260},
{265, 261},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{256, 276},
{266, 265},
{267, 264},
{269, 263},
{270, 271},
{271, 268},
{269, 297},
{272, 273},
{273, 270},
{274, 275},
{275, 272},
{277, 274},
{284, 285},
{285, 286},
{287, 288},
{288, 289},
{289, 290},
{277, 358},
{291, 292},
{269, 407},
{292, 293},
{295, 296},
{294, 295},
{297, 298},
{298, 299},
{299, 300},
{300, 301},
{301, 302},
{302, 303},
{303, 304},
{304, 305},
{305, 306},
{307, 308},
{308, 309},
{310, 311},
{269, 263},
{294, 385},
{271, 268},
{269, 297},
{272, 273},
{273, 270},
{274, 275},
{275, 272},
{277, 274},
{284, 285},
{285, 286},
{287, 288},
{288, 289},
{289, 290},
{277, 358},
{291, 292},
{269, 407},
{292, 293},
{295, 296},
{294, 295},
{297, 298},
{298, 299},
{299, 300},
{300, 301},
{301, 302},
{302, 303},
{303, 304},
{304, 305},
{305, 306},
{307, 308},
{308, 309},
{310, 311},
{311, 312},
{294, 385},
{314, 315},
{315, 316},
{317, 343},
{318, 319},
{319, 320},
{322, 323},
{314, 346},
{323, 324},
{325, 326},
{326, 327},
{327, 328},
{328, 329},
{329, 330},
{317, 318},
{330, 331},
{331, 332},
{333, 334},
{334, 335},
{335, 336},
{333, 414},
{340, 341},
{341, 342},
{343, 344},
{344, 345},
{346, 347},
{347, 348},
{348, 349},
{349, 350},
{350, 351},
{351, 352},
{311, 312},
{353, 354},
{314, 315},
{315, 316},
{317, 343},
{318, 319},
{319, 320},
{322, 323},
{314, 346},
{323, 324},
{325, 326},
{326, 327},
{327, 328},
{328, 329},
{329, 330},
{317, 318},
{330, 331},
{331, 332},
{333, 334},
{334, 335},
{335, 336},
{333, 414},
{340, 341},
{341, 342},
{343, 344},
{344, 345},
{346, 347},
{347, 348},
{348, 349},
{349, 350},
{350, 351},
{351, 352},
{354, 355},
{353, 354},
{358, 359},
{359, 360},
{360, 361},
{361, 362},
{364, 365},
{365, 366},
{367, 368},
{370, 371},
{372, 373},
{374, 375},
{372, 388},
{375, 376},
{385, 386},
{389, 390},
{397, 398},
{398, 399},
{400, 401},
{402, 403},
{403, 404},
{404, 405},
{405, 406},
{407, 408},
{408, 409},
{409, 410},
{410, 411},
{418, 419},
{419, 420},
{420, 421},
{421, 422},
{422, 423},
{354, 355},
{0, 0},
{358, 359},
{359, 360},
{360, 361},
{361, 362},
{364, 365},
{365, 366},
{367, 368},
{370, 371},
{372, 373},
{374, 375},
{372, 388},
{375, 376},
{385, 386},
{389, 390},
{397, 398},
{398, 399},
{400, 401},
{402, 403},
{403, 404},
{404, 405},
{405, 406},
{407, 408},
{408, 409},
{409, 410},
{410, 411},
{418, 419},
{419, 420},
{420, 421},
{421, 422},
{422, 423},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
};
static	yyCombType *	yyBasePtr	[yyDStateCount + 1] = {& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [116],
& yyComb [0],
& yyComb [232],
& yyComb [0],
& yyComb [320],
& yyComb [20],
& yyComb [18],
& yyComb [437],
& yyComb [0],
& yyComb [1],
& yyComb [516],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [596],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [84],
& yyComb [200],
& yyComb [0],
& yyComb [0],
& yyComb [309],
& yyComb [110],
& yyComb [125],
& yyComb [218],
& yyComb [289],
& yyComb [301],
& yyComb [302],
& yyComb [303],
& yyComb [313],
& yyComb [315],
& yyComb [317],
& yyComb [316],
& yyComb [318],
& yyComb [319],
& yyComb [322],
& yyComb [323],
& yyComb [324],
& yyComb [325],
& yyComb [326],
& yyComb [327],
& yyComb [328],
& yyComb [329],
& yyComb [671],
& yyComb [331],
& yyComb [333],
& yyComb [334],
& yyComb [506],
& yyComb [751],
& yyComb [500],
& yyComb [501],
& yyComb [502],
& yyComb [504],
& yyComb [582],
& yyComb [831],
& yyComb [567],
& yyComb [652],
& yyComb [911],
& yyComb [574],
& yyComb [577],
& yyComb [648],
& yyComb [991],
& yyComb [648],
& yyComb [649],
& yyComb [726],
& yyComb [727],
& yyComb [728],
& yyComb [729],
& yyComb [731],
& yyComb [806],
& yyComb [807],
& yyComb [808],
& yyComb [809],
& yyComb [1071],
& yyComb [828],
& yyComb [903],
& yyComb [1129],
& yyComb [1124],
& yyComb [1127],
& yyComb [1198],
& yyComb [903],
& yyComb [1254],
& yyComb [896],
& yyComb [1257],
& yyComb [1130],
& yyComb [895],
& yyComb [1180],
& yyComb [986],
& yyComb [1255],
& yyComb [981],
& yyComb [983],
& yyComb [984],
& yyComb [1327],
& yyComb [1350],
& yyComb [23],
& yyComb [24],
& yyComb [25],
& yyComb [1382],
& yyComb [25],
& yyComb [0],
& yyComb [0],
& yyComb [1473],
& yyComb [1568],
& yyComb [113],
& yyComb [1],
& yyComb [58],
& yyComb [151],
& yyComb [1647],
& yyComb [1670],
& yyComb [1708],
& yyComb [1360],
& yyComb [1731],
& yyComb [1741],
& yyComb [1779],
& yyComb [1840],
& yyComb [1119],
& yyComb [1142],
& yyComb [1064],
& yyComb [1844],
& yyComb [1049],
& yyComb [1050],
& yyComb [1051],
& yyComb [1053],
& yyComb [1248],
& yyComb [1118],
& yyComb [1139],
& yyComb [1849],
& yyComb [1159],
& yyComb [1165],
& yyComb [1850],
& yyComb [1852],
& yyComb [1852],
& yyComb [1245],
& yyComb [1250],
& yyComb [1842],
& yyComb [1186],
& yyComb [1262],
& yyComb [1898],
& yyComb [1962],
& yyComb [1275],
& yyComb [1321],
& yyComb [1309],
& yyComb [1310],
& yyComb [1895],
& yyComb [1321],
& yyComb [1322],
& yyComb [1372],
& yyComb [2021],
& yyComb [1889],
& yyComb [1833],
& yyComb [1897],
& yyComb [1369],
& yyComb [1370],
& yyComb [1371],
& yyComb [1373],
& yyComb [1887],
& yyComb [2007],
& yyComb [1624],
& yyComb [1625],
& yyComb [1626],
& yyComb [1853],
& yyComb [1906],
& yyComb [1909],
& yyComb [2013],
& yyComb [1650],
& yyComb [2021],
& yyComb [2015],
& yyComb [2018],
& yyComb [2039],
& yyComb [1868],
& yyComb [2059],
& yyComb [1912],
& yyComb [1940],
& yyComb [2063],
& yyComb [1959],
& yyComb [2062],
& yyComb [1977],
& yyComb [2030],
& yyComb [2076],
& yyComb [2075],
& yyComb [2034],
& yyComb [2035],
& yyComb [2052],
& yyComb [2075],
& yyComb [2066],
& yyComb [2085],
& yyComb [2077],
& yyComb [2080],
& yyComb [2106],
& yyComb [2095],
& yyComb [2082],
& yyComb [2108],
& yyComb [2101],
& yyComb [2134],
& yyComb [2188],
& yyComb [2137],
& yyComb [2083],
& yyComb [2086],
& yyComb [2124],
& yyComb [2241],
& yyComb [2118],
& yyComb [2130],
& yyComb [2153],
& yyComb [2168],
& yyComb [2180],
& yyComb [2245],
& yyComb [2236],
& yyComb [34],
& yyComb [2172],
& yyComb [2199],
& yyComb [2235],
& yyComb [2249],
& yyComb [2252],
& yyComb [2242],
& yyComb [2255],
& yyComb [35],
& yyComb [2241],
& yyComb [36],
& yyComb [2312],
& yyComb [2256],
& yyComb [2242],
& yyComb [2267],
& yyComb [2270],
& yyComb [2262],
& yyComb [2263],
& yyComb [2257],
& yyComb [2293],
& yyComb [2311],
& yyComb [2321],
& yyComb [2322],
& yyComb [47],
& yyComb [2370],
& yyComb [2322],
& yyComb [2370],
& yyComb [2359],
& yyComb [2373],
& yyComb [2360],
& yyComb [2377],
& yyComb [48],
& yyComb [2372],
& yyComb [17],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [2378],
& yyComb [2358],
& yyComb [0],
& yyComb [2369],
& yyComb [2382],
& yyComb [2375],
& yyComb [0],
& yyComb [2368],
& yyComb [2382],
& yyComb [0],
& yyComb [2391],
& yyComb [2375],
& yyComb [0],
& yyComb [2384],
& yyComb [2387],
& yyComb [2374],
& yyComb [2378],
& yyComb [2396],
& yyComb [2378],
& yyComb [2390],
& yyComb [2385],
& yyComb [2387],
& yyComb [0],
& yyComb [2390],
& yyComb [2391],
& yyComb [0],
& yyComb [2389],
& yyComb [2421],
& yyComb [0],
& yyComb [0],
& yyComb [2424],
& yyComb [2422],
& yyComb [0],
& yyComb [2432],
& yyComb [2433],
& yyComb [2431],
& yyComb [0],
& yyComb [0],
& yyComb [2435],
& yyComb [2426],
& yyComb [0],
& yyComb [2446],
& yyComb [2434],
& yyComb [2430],
& yyComb [2434],
& yyComb [2436],
& yyComb [2435],
& yyComb [2434],
& yyComb [0],
& yyComb [2446],
& yyComb [2455],
& yyComb [2438],
& yyComb [0],
& yyComb [0],
& yyComb [182],
& yyComb [0],
& yyComb [2458],
& yyComb [2435],
& yyComb [0],
& yyComb [2441],
& yyComb [2443],
& yyComb [0],
& yyComb [2449],
& yyComb [2461],
& yyComb [2445],
& yyComb [2457],
& yyComb [2452],
& yyComb [2454],
& yyComb [0],
& yyComb [2452],
& yyComb [2481],
& yyComb [0],
& yyComb [85],
& yyComb [0],
& yyComb [2480],
& yyComb [2490],
& yyComb [2485],
& yyComb [2491],
& yyComb [0],
& yyComb [0],
& yyComb [2492],
& yyComb [2490],
& yyComb [0],
& yyComb [2491],
& yyComb [0],
& yyComb [0],
& yyComb [2506],
& yyComb [0],
& yyComb [2493],
& yyComb [0],
& yyComb [2498],
& yyComb [2510],
& yyComb [0],
& yyComb [90],
& yyComb [0],
& yyComb [0],
& yyComb [149],
& yyComb [0],
& yyComb [183],
& yyComb [0],
& yyComb [0],
& yyComb [2511],
& yyComb [0],
& yyComb [205],
& yyComb [0],
& yyComb [2497],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [2496],
& yyComb [2498],
& yyComb [0],
& yyComb [2499],
& yyComb [0],
& yyComb [2513],
& yyComb [2507],
& yyComb [2521],
& yyComb [2511],
& yyComb [0],
& yyComb [2504],
& yyComb [2524],
& yyComb [2512],
& yyComb [2507],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [2526],
& yyComb [2511],
& yyComb [2529],
& yyComb [2513],
& yyComb [2507],
& yyComb [0],
& yyComb [0],
};
static	yyStateRange	yyDefault	[yyDStateCount + 1] = {0,
11,
1,
11,
3,
11,
5,
0,
13,
0,
9,
0,
0,
0,
13,
13,
13,
13,
13,
13,
0,
0,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
55,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
0,
55,
41,
0,
55,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
41,
0,
81,
81,
81,
81,
0,
86,
86,
86,
86,
86,
0,
92,
95,
0,
95,
95,
95,
0,
99,
99,
99,
99,
99,
99,
99,
99,
99,
99,
99,
0,
111,
111,
91,
92,
99,
0,
117,
120,
86,
124,
135,
122,
122,
126,
135,
126,
126,
126,
131,
0,
148,
149,
150,
131,
0,
133,
132,
122,
122,
130,
146,
145,
147,
131,
131,
131,
131,
131,
131,
122,
154,
122,
135,
154,
135,
156,
156,
156,
156,
176,
161,
164,
176,
164,
164,
171,
171,
186,
176,
161,
176,
172,
172,
171,
0,
161,
164,
170,
170,
176,
181,
181,
181,
171,
161,
186,
176,
188,
188,
188,
188,
161,
176,
194,
194,
194,
199,
161,
161,
232,
201,
232,
232,
232,
232,
206,
232,
208,
208,
232,
211,
232,
213,
217,
205,
232,
217,
204,
217,
205,
201,
203,
204,
204,
232,
201,
201,
201,
201,
211,
0,
204,
208,
208,
211,
213,
226,
201,
203,
276,
276,
276,
276,
256,
256,
276,
276,
276,
276,
276,
276,
256,
276,
256,
278,
276,
276,
276,
276,
276,
276,
276,
276,
276,
256,
276,
256,
276,
276,
276,
276,
276,
276,
276,
256,
276,
0,
0,
0,
0,
0,
0,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
278,
0,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
278,
0,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
278,
0,
0,
278,
0,
278,
0,
0,
276,
276,
278,
276,
276,
276,
0,
0,
0,
0,
0,
278,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
276,
0,
276,
276,
0,
0,
0,
276,
276,
276,
276,
276,
276,
396,
};
static	yyStateRange	yyEobTrans	[yyDStateCount + 1] = {0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
10,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
};

static	yyStateRange	yyInitStateStack [yyInitBufferSize] = {0};
static	yyStateRange *	yyStateStack	= yyInitStateStack;
static	unsigned long	yyStateStackSize= yyInitBufferSize;
static	yyStateRange	yyStartState	= 0;
static	yyStateRange	yyPreviousStart	= 1;

static  short		yySourceFile	;
static	bool		yyEof		;
static	unsigned char *	yyChBufferPtr	;
static	unsigned char *	yyChBufferStart	;
static	unsigned long	yyChBufferSize	;
static	unsigned char *	yyChBufferIndex	= ((unsigned char *) yyComb) + 2; /* dirty trick */
static	int		yyBytesRead	;
static	int		yyLineCount	;
static	unsigned char *	yyLineStart	;

static	struct {
	short		yySourceFile	;
	bool		yyEof		;
	unsigned char *	yyChBufferPtr	;
	unsigned char *	yyChBufferStart	;
	unsigned long	yyChBufferSize	;
	unsigned char *	yyChBufferIndex	;
	int		yyBytesRead	;
	int		yyLineCount	;
	unsigned char *	yyLineStart	;
	} yyFileStack [yyFileStackSize + 1], * yyFileStackPtr = yyFileStack;

static	unsigned char	yyToLower	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '[', '\\', ']', '^', '_',
'`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};

static	unsigned char	yyToUpper	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_',
'`', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};
 
static	void	yyInitialize	();
static	void	yyErrorMessage	ARGS((int yyErrorCode));
static	char	input		();
/* line 39 "vhdl.rex" */


void ErrorAttribute
# if defined __STDC__ | defined __cplusplus
 (int Token, tScanAttribute * pAttribute)
# else
 (Token, pAttribute) int Token; tScanAttribute * pAttribute;
# endif
{
 pAttribute->Position = Attribute.Position;
 switch (Token) {
 case /* identifier */ 1: 
  pAttribute->identifier.Id = (tString) NULL;
  ;
 break;
 case /* decimal_literal */ 2: 
 pAttribute->decimal_literal.Val = 0;
 ;
 break;
 case /* based_literal */ 3: 
 pAttribute->based_literal.Val = 0;
 ;
 break;
 case /* character_literal */ 4: 
 pAttribute->character_literal.Val = '\0';
 ;
 break;
 case /* string_literal */ 5: 
 pAttribute->string_literal.Str = NULL;
 ;
 break;
 case /* bit_string_literal */ 6: 
0, NULL;
 ;
 break;
 }
}



 
int GetToken ()
{
   register	yyStateRange	yyState;
   register	yyStateRange *	yyStatePtr;
   register	unsigned char * yyChBufferIndexReg;
   register	yyCombType * *	yyBasePtrReg = yyBasePtr;
   
yyBegin:
   yyState		= yyStartState;		/* initialize */
   yyStatePtr		= & yyStateStack [1];
   yyChBufferIndexReg 	= yyChBufferIndex;
   TokenPtr	 	= (char *) yyChBufferIndexReg;
 
   /* ASSERT yyChBuffer [yyChBufferIndex] == first character */
 
yyContinue:		/* continue after sentinel or skipping blanks */
   for (;;) {		/* execute as many state transitions as possible */
					/* determine next state and get next character */
      register yyCombType * yyTablePtr = (yyBasePtrReg [yyState] + * yyChBufferIndexReg ++);
      if (yyTablePtr->yyCheck == yyState) {
	 yyState = yyTablePtr->yyNext;
	 * yyStatePtr ++ = yyState;		/* push state */
	 goto yyContinue;
      }
      yyChBufferIndexReg --;			/* reconsider character */
      if ((yyState = yyDefault [yyState]) == yyDNoState) break;
   }
 
   for (;;) {					/* search for last final state */
      TokenLength = yyChBufferIndexReg - (unsigned char *) TokenPtr;
      yyChBufferIndex = yyChBufferIndexReg;
switch (* -- yyStatePtr) {
case 56:;
case 138:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 102 "vhdl.rex" */
{ yyStart(STD);
          Attribute.based_literal.Val = ScanBasedLit (TokenPtr, TokenLength);
	  return 3; 
} yy1: goto yyBegin;
case 55:;
case 137:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 107 "vhdl.rex" */
{ yyStart(STD);
          Attribute.based_literal.Val = ScanBasedLit (TokenPtr, TokenLength);
	  return 3; 
} yy2: goto yyBegin;
case 7:;
case 59:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 112 "vhdl.rex" */
{ yyStart (STD);
          Attribute.decimal_literal.Val = ScanDecimalLit (TokenPtr, TokenLength);
	  return 2; 
} yy3: goto yyBegin;
case 21:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 117 "vhdl.rex" */
{ yyStart (STD);
          ScanBitStringLit (TokenPtr, TokenLength, 
		&Attribute.bit_string_literal.Val);
          return 6; 
} yy4: goto yyBegin;
case 20:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 123 "vhdl.rex" */
{ yyStart (STD);
          ScanBitStringLit (TokenPtr, TokenLength, 
		&Attribute.bit_string_literal.Val);
          return 6; 
} yy5: goto yyBegin;
case 58:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 129 "vhdl.rex" */
{ Attribute.character_literal.Val = TokenPtr[1];
	  return 4; 
} yy6: goto yyBegin;
case 12:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 133 "vhdl.rex" */
{ yyStart(QUOTE);
	  Attribute.string_literal.Str = QuoteStrnDup (TokenPtr, TokenLength);
	  return 5; 
} yy7: goto yyBegin;
case 11:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 138 "vhdl.rex" */
{ yyStart(QUOTE);
	  Attribute.string_literal.Str = QuoteStrnDup (TokenPtr, TokenLength);
	  return 5; 
} yy8: goto yyBegin;
case 10:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 142 "vhdl.rex" */
{
} yy9: goto yyBegin;
case 395:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 144 "vhdl.rex" */
{ yyStart(QUOTE); return 26; 
} yy10: goto yyBegin;
case 424:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 145 "vhdl.rex" */
{ yyStart(AQUOTE); return 25; 
} yy11: goto yyBegin;
case 53:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 148 "vhdl.rex" */
{ yyStart(QUOTE);
          Attribute.identifier.Id = StrnDupLwr(TokenPtr, TokenLength);
          return 1; 
} yy12: goto yyBegin;
case 423:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 152 "vhdl.rex" */
{  yyStart (STD); return 7; 
} yy13: goto yyBegin;
case 417:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 153 "vhdl.rex" */
{  yyStart (STD); return 8; 
} yy14: goto yyBegin;
case 416:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 154 "vhdl.rex" */
{  yyStart (STD); return 9; 
} yy15: goto yyBegin;
case 32:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 155 "vhdl.rex" */
{  yyStart (STD); return 10; 
} yy16: goto yyBegin;
case 415:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 156 "vhdl.rex" */
{  yyStart (STD); return 11; 
} yy17: goto yyBegin;
case 414:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 157 "vhdl.rex" */
{  yyStart (STD); return 12; 
} yy18: goto yyBegin;
case 38:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 158 "vhdl.rex" */
{  yyStart (STD); return 13; 
} yy19: goto yyBegin;
case 413:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 159 "vhdl.rex" */
{  yyStart (STD); return 14; 
} yy20: goto yyBegin;
case 41:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 160 "vhdl.rex" */
{  yyStart (STD); return 15; 
} yy21: goto yyBegin;
case 412:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 161 "vhdl.rex" */
{  yyStart (STD); return 16; 
} yy22: goto yyBegin;
case 411:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 162 "vhdl.rex" */
{  yyStart (STD); return 17; 
} yy23: goto yyBegin;
case 19:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 163 "vhdl.rex" */
{  yyStart (STD); return 18; 
} yy24: goto yyBegin;
case 406:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 164 "vhdl.rex" */
{  yyStart (STD); return 19; 
} yy25: goto yyBegin;
case 356:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 165 "vhdl.rex" */
{  yyStart (STD); return 20; 
} yy26: goto yyBegin;
case 219:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 166 "vhdl.rex" */
{  yyStart (STD); return 21; 
} yy27: goto yyBegin;
case 401:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 167 "vhdl.rex" */
{  yyStart (STD); return 22; 
} yy28: goto yyBegin;
case 399:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 168 "vhdl.rex" */
{  yyStart (STD); return 23; 
} yy29: goto yyBegin;
case 57:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 169 "vhdl.rex" */
{  yyStart (STD); return 24; 
} yy30: goto yyBegin;
case 139:;
case 396:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 170 "vhdl.rex" */
{  yyStart (STD); return 25; 
} yy31: goto yyBegin;
case 23:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 172 "vhdl.rex" */
{  yyStart (STD); return 27; 
} yy32: goto yyBegin;
case 18:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 173 "vhdl.rex" */
{  yyStart (STD); return 28; 
} yy33: goto yyBegin;
case 394:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 174 "vhdl.rex" */
{  yyStart (STD); return 29; 
} yy34: goto yyBegin;
case 393:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 175 "vhdl.rex" */
{  yyStart (STD); return 30; 
} yy35: goto yyBegin;
case 392:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 176 "vhdl.rex" */
{  yyStart (STD); return 31; 
} yy36: goto yyBegin;
case 391:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 177 "vhdl.rex" */
{  yyStart (STD); return 32; 
} yy37: goto yyBegin;
case 390:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 178 "vhdl.rex" */
{  yyStart (STD); return 33; 
} yy38: goto yyBegin;
case 388:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 179 "vhdl.rex" */
{  yyStart (STD); return 34; 
} yy39: goto yyBegin;
case 387:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 180 "vhdl.rex" */
{  yyStart (STD); return 35; 
} yy40: goto yyBegin;
case 380:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 181 "vhdl.rex" */
{  yyStart (STD); return 36; 
} yy41: goto yyBegin;
case 386:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 182 "vhdl.rex" */
{  yyStart (STD); return 37; 
} yy42: goto yyBegin;
case 48:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 183 "vhdl.rex" */
{  yyStart (STD); return 38; 
} yy43: goto yyBegin;
case 384:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 184 "vhdl.rex" */
{  yyStart (STD); return 39; 
} yy44: goto yyBegin;
case 9:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 185 "vhdl.rex" */
{  yyStart (STD); return 40; 
} yy45: goto yyBegin;
case 383:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 186 "vhdl.rex" */
{  yyStart (STD); return 41; 
} yy46: goto yyBegin;
case 382:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 187 "vhdl.rex" */
{  yyStart (STD); return 42; 
} yy47: goto yyBegin;
case 381:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 188 "vhdl.rex" */
{  yyStart (STD); return 43; 
} yy48: goto yyBegin;
case 338:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 189 "vhdl.rex" */
{  yyStart (STD); return 44; 
} yy49: goto yyBegin;
case 379:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 190 "vhdl.rex" */
{  yyStart (STD); return 45; 
} yy50: goto yyBegin;
case 377:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 191 "vhdl.rex" */
{  yyStart (STD); return 46; 
} yy51: goto yyBegin;
case 378:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 192 "vhdl.rex" */
{  yyStart (STD); return 47; 
} yy52: goto yyBegin;
case 376:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 193 "vhdl.rex" */
{  yyStart (STD); return 48; 
} yy53: goto yyBegin;
case 373:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 194 "vhdl.rex" */
{  yyStart (STD); return 49; 
} yy54: goto yyBegin;
case 371:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 195 "vhdl.rex" */
{  yyStart (STD); return 50; 
} yy55: goto yyBegin;
case 369:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 196 "vhdl.rex" */
{  yyStart (STD); return 51; 
} yy56: goto yyBegin;
case 368:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 197 "vhdl.rex" */
{  yyStart (STD); return 52; 
} yy57: goto yyBegin;
case 366:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 198 "vhdl.rex" */
{  yyStart (STD); return 53; 
} yy58: goto yyBegin;
case 363:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 199 "vhdl.rex" */
{  yyStart (STD); return 54; 
} yy59: goto yyBegin;
case 362:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 200 "vhdl.rex" */
{  yyStart (STD); return 55; 
} yy60: goto yyBegin;
case 357:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 201 "vhdl.rex" */
{  yyStart (STD); return 56; 
} yy61: goto yyBegin;
case 355:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 202 "vhdl.rex" */
{  yyStart (STD); return 57; 
} yy62: goto yyBegin;
case 14:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 203 "vhdl.rex" */
{  yyStart (STD); return 58; 
} yy63: goto yyBegin;
case 352:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 204 "vhdl.rex" */
{  yyStart (STD); return 59; 
} yy64: goto yyBegin;
case 52:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 205 "vhdl.rex" */
{  yyStart (STD); return 60; 
} yy65: goto yyBegin;
case 28:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 206 "vhdl.rex" */
{  yyStart (STD); return 61; 
} yy66: goto yyBegin;
case 345:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 207 "vhdl.rex" */
{  yyStart (STD); return 62; 
} yy67: goto yyBegin;
case 37:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 208 "vhdl.rex" */
{  yyStart (STD); return 63; 
} yy68: goto yyBegin;
case 342:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 209 "vhdl.rex" */
{  yyStart (STD); return 64; 
} yy69: goto yyBegin;
case 339:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 210 "vhdl.rex" */
{  yyStart (STD); return 65; 
} yy70: goto yyBegin;
case 337:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 211 "vhdl.rex" */
{  yyStart (STD); return 66; 
} yy71: goto yyBegin;
case 51:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 212 "vhdl.rex" */
{  yyStart (STD); return 67; 
} yy72: goto yyBegin;
case 29:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 213 "vhdl.rex" */
{  yyStart (STD); return 68; 
} yy73: goto yyBegin;
case 336:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 214 "vhdl.rex" */
{  yyStart (STD); return 69; 
} yy74: goto yyBegin;
case 44:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 215 "vhdl.rex" */
{  yyStart (STD); return 70; 
} yy75: goto yyBegin;
case 46:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 216 "vhdl.rex" */
{  yyStart (STD); return 71; 
} yy76: goto yyBegin;
case 13:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 217 "vhdl.rex" */
{  yyStart (STD); return 72; 
} yy77: goto yyBegin;
case 34:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 218 "vhdl.rex" */
{  yyStart (STD); return 73; 
} yy78: goto yyBegin;
case 54:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 219 "vhdl.rex" */
{  yyStart (STD); return 74; 
} yy79: goto yyBegin;
case 332:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 220 "vhdl.rex" */
{  yyStart (STD); return 75; 
} yy80: goto yyBegin;
case 49:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 221 "vhdl.rex" */
{  yyStart (STD); return 76; 
} yy81: goto yyBegin;
case 33:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 222 "vhdl.rex" */
{  yyStart (STD); return 77; 
} yy82: goto yyBegin;
case 47:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 223 "vhdl.rex" */
{  yyStart (STD); return 78; 
} yy83: goto yyBegin;
case 324:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 224 "vhdl.rex" */
{  yyStart (STD); return 79; 
} yy84: goto yyBegin;
case 321:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 225 "vhdl.rex" */
{  yyStart (STD); return 80; 
} yy85: goto yyBegin;
case 320:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 226 "vhdl.rex" */
{  yyStart (STD); return 81; 
} yy86: goto yyBegin;
case 316:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 227 "vhdl.rex" */
{  yyStart (STD); return 82; 
} yy87: goto yyBegin;
case 45:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 228 "vhdl.rex" */
{  yyStart (STD); return 83; 
} yy88: goto yyBegin;
case 50:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 229 "vhdl.rex" */
{  yyStart (STD); return 84; 
} yy89: goto yyBegin;
case 30:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 230 "vhdl.rex" */
{  yyStart (STD); return 85; 
} yy90: goto yyBegin;
case 313:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 231 "vhdl.rex" */
{  yyStart (STD); return 86; 
} yy91: goto yyBegin;
case 27:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 232 "vhdl.rex" */
{  yyStart (STD); return 87; 
} yy92: goto yyBegin;
case 36:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 233 "vhdl.rex" */
{  yyStart (STD); return 88; 
} yy93: goto yyBegin;
case 35:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 234 "vhdl.rex" */
{  yyStart (STD); return 89; 
} yy94: goto yyBegin;
case 26:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 235 "vhdl.rex" */
{  yyStart (STD); return 90; 
} yy95: goto yyBegin;
case 17:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 236 "vhdl.rex" */
{  yyStart (STD); return 91; 
} yy96: goto yyBegin;
case 16:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 237 "vhdl.rex" */
{  yyStart (STD); return 92; 
} yy97: goto yyBegin;
case 312:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 238 "vhdl.rex" */
{  yyStart (STD); return 93; 
} yy98: goto yyBegin;
case 43:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 239 "vhdl.rex" */
{  yyStart (STD); return 94; 
} yy99: goto yyBegin;
case 39:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 240 "vhdl.rex" */
{  yyStart (STD); return 95; 
} yy100: goto yyBegin;
case 309:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 241 "vhdl.rex" */
{  yyStart (STD); return 96; 
} yy101: goto yyBegin;
case 25:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 242 "vhdl.rex" */
{  yyStart (STD); return 97; 
} yy102: goto yyBegin;
case 15:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 243 "vhdl.rex" */
{  yyStart (STD); return 98; 
} yy103: goto yyBegin;
case 306:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 244 "vhdl.rex" */
{  yyStart (STD); return 99; 
} yy104: goto yyBegin;
case 22:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 245 "vhdl.rex" */
{  yyStart (STD); return 100; 
} yy105: goto yyBegin;
case 296:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 246 "vhdl.rex" */
{  yyStart (STD); return 101; 
} yy106: goto yyBegin;
case 24:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 247 "vhdl.rex" */
{  yyStart (STD); return 102; 
} yy107: goto yyBegin;
case 293:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 248 "vhdl.rex" */
{  yyStart (STD); return 103; 
} yy108: goto yyBegin;
case 31:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 249 "vhdl.rex" */
{  yyStart (STD); return 104; 
} yy109: goto yyBegin;
case 40:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 250 "vhdl.rex" */
{  yyStart (STD); return 105; 
} yy110: goto yyBegin;
case 290:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 251 "vhdl.rex" */
{  yyStart (STD); return 106; 
} yy111: goto yyBegin;
case 42:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 252 "vhdl.rex" */
{  yyStart (STD); return 107; 
} yy112: goto yyBegin;
case 286:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 253 "vhdl.rex" */
{  yyStart (STD); return 108; 
} yy113: goto yyBegin;
case 8:;
case 60:;
case 61:;
case 62:;
case 63:;
case 64:;
case 65:;
case 66:;
case 67:;
case 68:;
case 69:;
case 70:;
case 71:;
case 72:;
case 73:;
case 74:;
case 75:;
case 76:;
case 77:;
case 78:;
case 79:;
case 80:;
case 81:;
case 82:;
case 83:;
case 84:;
case 85:;
case 86:;
case 87:;
case 88:;
case 89:;
case 90:;
case 91:;
case 92:;
case 93:;
case 94:;
case 95:;
case 96:;
case 97:;
case 98:;
case 99:;
case 100:;
case 101:;
case 102:;
case 103:;
case 104:;
case 105:;
case 106:;
case 107:;
case 108:;
case 109:;
case 110:;
case 111:;
case 112:;
case 113:;
case 114:;
case 115:;
case 116:;
case 117:;
case 118:;
case 119:;
case 120:;
case 121:;
case 122:;
case 123:;
case 124:;
case 125:;
case 126:;
case 127:;
case 128:;
case 129:;
case 152:;
case 153:;
case 154:;
case 155:;
case 156:;
case 157:;
case 158:;
case 159:;
case 160:;
case 161:;
case 162:;
case 163:;
case 164:;
case 165:;
case 166:;
case 167:;
case 168:;
case 169:;
case 170:;
case 171:;
case 172:;
case 173:;
case 174:;
case 175:;
case 177:;
case 178:;
case 179:;
case 180:;
case 181:;
case 182:;
case 183:;
case 184:;
case 185:;
case 186:;
case 187:;
case 188:;
case 189:;
case 190:;
case 191:;
case 192:;
case 193:;
case 194:;
case 195:;
case 196:;
case 197:;
case 198:;
case 199:;
case 200:;
case 201:;
case 202:;
case 203:;
case 204:;
case 205:;
case 206:;
case 207:;
case 208:;
case 209:;
case 210:;
case 211:;
case 212:;
case 213:;
case 214:;
case 215:;
case 216:;
case 217:;
case 218:;
case 220:;
case 221:;
case 222:;
case 223:;
case 224:;
case 225:;
case 226:;
case 227:;
case 228:;
case 229:;
case 230:;
case 231:;
case 233:;
case 234:;
case 235:;
case 236:;
case 237:;
case 238:;
case 239:;
case 240:;
case 241:;
case 242:;
case 243:;
case 244:;
case 245:;
case 247:;
case 248:;
case 249:;
case 250:;
case 251:;
case 252:;
case 253:;
case 254:;
case 255:;
case 257:;
case 258:;
case 259:;
case 260:;
case 261:;
case 262:;
case 263:;
case 264:;
case 265:;
case 267:;
case 268:;
case 269:;
case 270:;
case 271:;
case 272:;
case 273:;
case 274:;
case 275:;
case 276:;
case 277:;
case 284:;
case 285:;
case 287:;
case 288:;
case 289:;
case 291:;
case 292:;
case 294:;
case 295:;
case 297:;
case 298:;
case 299:;
case 300:;
case 301:;
case 302:;
case 303:;
case 304:;
case 305:;
case 307:;
case 308:;
case 310:;
case 311:;
case 314:;
case 315:;
case 317:;
case 318:;
case 319:;
case 322:;
case 323:;
case 325:;
case 326:;
case 327:;
case 328:;
case 329:;
case 330:;
case 331:;
case 333:;
case 334:;
case 335:;
case 340:;
case 341:;
case 343:;
case 344:;
case 346:;
case 347:;
case 348:;
case 349:;
case 350:;
case 351:;
case 353:;
case 354:;
case 358:;
case 359:;
case 360:;
case 361:;
case 364:;
case 365:;
case 367:;
case 370:;
case 372:;
case 374:;
case 375:;
case 385:;
case 389:;
case 397:;
case 398:;
case 400:;
case 402:;
case 403:;
case 404:;
case 405:;
case 407:;
case 408:;
case 409:;
case 410:;
case 418:;
case 419:;
case 420:;
case 421:;
case 422:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 257 "vhdl.rex" */
{ yyStart(QUOTE);
          Attribute.identifier.Id = StrnDupLwr(TokenPtr, TokenLength);
          return 1; 
} yy114: goto yyBegin;
case 283:;
{/* BlankAction */
while (* yyChBufferIndexReg ++ == ' ') ;
TokenPtr = (char *) -- yyChBufferIndexReg;
yyState = yyStartState;
yyStatePtr = & yyStateStack [1];
goto yyContinue;
} yy115: goto yyBegin;
case 282:;
{/* TabAction */
yyLineStart -= 7 - ((unsigned char *) TokenPtr - yyLineStart - 1) & 0x7; /* % 8 */
} yy116: goto yyBegin;
case 281:;
{/* EolAction */
yyLineCount ++;
yyLineStart = yyChBufferIndexReg - 1;
} yy117: goto yyBegin;
case 1:;
case 2:;
case 3:;
case 4:;
case 5:;
case 6:;
case 130:;
case 131:;
case 132:;
case 133:;
case 134:;
case 135:;
case 136:;
case 140:;
case 141:;
case 142:;
case 143:;
case 144:;
case 145:;
case 146:;
case 147:;
case 148:;
case 149:;
case 150:;
case 151:;
case 176:;
case 232:;
case 246:;
case 256:;
case 266:;
case 278:;
	 /* non final states */
	 yyChBufferIndexReg --;			/* return character */
	 break;
 
case 280:
	 Attribute.Position.Line   = yyLineCount;
	 Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
      /* TokenLength   = 1; */
	 yyChBufferIndex = ++ yyChBufferIndexReg;
	 {
/* line 80 "vhdl.rex" */
 

MessageI ("illegal character", xxError, Attribute.Position, xxCharacter, 
		TokenPtr);

	 }
	 goto yyBegin;
 
      case yyDNoState:				/* automatic initialization */
	 yyInitialize ();
	 yySourceFile = StdIn;
	 goto yyBegin;

case 279:
	 yyChBufferIndex = -- yyChBufferIndexReg; /* undo last state transition */
	 if (-- TokenLength == 0) {		/* get previous state */
	    yyState = yyStartState;
	 } else {
	    yyState = * (yyStatePtr - 1);
	 }

	 if (yyChBufferIndex != & yyChBufferStart [yyBytesRead]) {
						/* end of buffer sentinel in buffer */
	    if ((yyState = yyEobTrans [yyState]) == yyDNoState) continue;
	    yyChBufferIndexReg ++;
	    * yyStatePtr ++ = yyState;		/* push state */
	    goto yyContinue;
	 }
						/* end of buffer reached */
	 {  /* copy initial part of token in front of the input buffer */
	    register char * yySource = TokenPtr;
	    register char * yyTarget = TokenPtr = (char *) & yyChBufferPtr [yyMaxAlign - TokenLength % yyMaxAlign];
	    if (yySource != yyTarget) {
	       while (yySource < (char *) yyChBufferIndexReg) * yyTarget ++ = * yySource ++;
	       yyLineStart += (unsigned char *) yyTarget - yyChBufferStart - yyBytesRead;
	       yyChBufferStart = (unsigned char *) yyTarget;
	    } else {
	       yyChBufferStart = yyChBufferIndexReg;
	    }
	 }

	 if (! yyEof) {				/* read buffer and restart */
	    int yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - TokenLength));
	    if (yyChBufferFree < yyChBufferSize / 8) {
	       register int yyDelta;
	       register unsigned char * yyOldChBufferPtr = yyChBufferPtr;
	       ExtendArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
	       if (yyChBufferPtr == NULL) yyErrorMessage (1);
	       yyDelta = yyChBufferPtr - yyOldChBufferPtr;
	       yyChBufferStart	+= yyDelta;
	       yyLineStart	+= yyDelta;
	       TokenPtr	+= yyDelta;
	       yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - TokenLength));
	       if (yyStateStackSize < yyChBufferSize) {
		  yyStateRange * yyOldStateStack = yyStateStack;
		  ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
		  if (yyStateStack == NULL) yyErrorMessage (1);
		  yyStatePtr	+= yyStateStack - yyOldStateStack;
	       }
	    }
	    yyChBufferIndex = yyChBufferIndexReg = yyChBufferStart;
	    yyBytesRead = GetLine (yySourceFile, (char *) yyChBufferIndex, yyChBufferFree);
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	    goto yyContinue;
	 }

	 if (TokenLength == 0) {		/* end of file reached */
	    Attribute.Position.Line   = yyLineCount;
	    Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
	    CloseFile ();
	    if (yyFileStackPtr == yyFileStack) {
	    }
	    if (yyFileStackPtr == yyFileStack) return EofToken;
	    goto yyBegin;
	 }
	 break;
 
      default:
	 yyErrorMessage (0);
      }
   }
}
 
void BeginFile
# if defined __STDC__ | defined __cplusplus
   (char * yyFileName)
# else
   (yyFileName) char * yyFileName;
# endif
   {
      yyInitialize ();
      yySourceFile = BeginSource (yyFileName);
   }

static void yyInitialize ()
   {
      if (yyFileStackPtr >= yyFileStack + yyFileStackSize) yyErrorMessage (2);
      yyFileStackPtr ++;			/* push file */
      yyFileStackPtr->yySourceFile	= yySourceFile		;
      yyFileStackPtr->yyEof		= yyEof			;
      yyFileStackPtr->yyChBufferPtr	= yyChBufferPtr		;
      yyFileStackPtr->yyChBufferStart	= yyChBufferStart	;
      yyFileStackPtr->yyChBufferSize	= yyChBufferSize	;
      yyFileStackPtr->yyChBufferIndex	= yyChBufferIndex	;
      yyFileStackPtr->yyBytesRead	= yyBytesRead		;
      yyFileStackPtr->yyLineCount	= yyLineCount		;
      yyFileStackPtr->yyLineStart	= yyLineStart		;
						/* initialize file state */
      yyChBufferSize	   = yyInitBufferSize;
      MakeArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
      if (yyChBufferPtr == NULL) yyErrorMessage (1);
      yyChBufferStart	   = & yyChBufferPtr [yyMaxAlign];
      yyChBufferStart [-1] = yyEolCh;		/* begin of line indicator */
      yyChBufferStart [ 0] = yyEobCh;		/* end of buffer sentinel */
      yyChBufferStart [ 1] = '\0';
      yyChBufferIndex	   = yyChBufferStart;
      yyEof		   = false;
      yyBytesRead	   = 0;
      yyLineCount	   = 1;
      yyLineStart	   = & yyChBufferStart [-1];
      if (yyStartState == 0) {
	 yyStartState	   = STD;
	 yyStateStack [0]  = yyDefaultState;	/* stack underflow sentinel */
      }
   }

void CloseFile ()
   {
      if (yyFileStackPtr == yyFileStack) yyErrorMessage (3);
      CloseSource (yySourceFile);
      ReleaseArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
						/* pop file */
      yySourceFile	= yyFileStackPtr->yySourceFile		;
      yyEof		= yyFileStackPtr->yyEof			;
      yyChBufferPtr	= yyFileStackPtr->yyChBufferPtr		;
      yyChBufferStart	= yyFileStackPtr->yyChBufferStart	;
      yyChBufferSize	= yyFileStackPtr->yyChBufferSize	;
      yyChBufferIndex	= yyFileStackPtr->yyChBufferIndex	;
      yyBytesRead	= yyFileStackPtr->yyBytesRead		;
      yyLineCount	= yyFileStackPtr->yyLineCount		;
      yyLineStart	= yyFileStackPtr->yyLineStart		;
      yyFileStackPtr --;		
   }
 
int GetWord
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = * yySource ++;
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
int GetLower
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToLower [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
int GetUpper
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToUpper [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
static char input ()
   {
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) {
	 if (! yyEof) {
	    yyLineStart -= yyBytesRead;
	    yyChBufferIndex = yyChBufferStart = yyChBufferPtr;
	    yyBytesRead = GetLine (yySourceFile, (char *) yyChBufferIndex,
	       (int) Exp2 (Log2 (yyChBufferSize)));
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	 }
      }
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) return '\0';
      else return * yyChBufferIndex ++;
   }

void BeginScanner ()
   {
   }
 
void CloseScanner ()
   {
   }
 
static void yyErrorMessage
# if defined __STDC__ | defined __cplusplus
   (int yyErrorCode)
# else
   (yyErrorCode) int yyErrorCode;
# endif
   {
      WritePosition (stderr, Attribute.Position);
      switch (yyErrorCode) {
      case 0: (void) fprintf (stderr, ": Scanner: internal error\n"); break;
      case 1: (void) fprintf (stderr, ": Scanner: out of memory\n"); break;
      case 2: (void) fprintf (stderr, ": Scanner: too many nested include files\n"); break;
      case 3: (void) fprintf (stderr, ": Scanner: file stack underflow (too many calls of CloseFile)\n"); break;
      }
      Scanner_Exit ();
   }
