/* $Id: Scanner.c,v 2.16 1992/08/18 09:05:32 grosch rel $ */

# define bool		char
# define true		1
# define false		0
# define StdIn		0
 
# include "Scanner.h"
# include "Source.h"
# include "System.h"
# include "General.h"
# include "DynArray.h"
# include "Positions.h"
# include <stdio.h>
 
# if defined __STDC__ | defined __cplusplus
#  include <stdlib.h>
# else
/* extern char * malloc ();
   extern void free (); */
# endif

# define yyTabSpace	8

# define yyStart(State)	{ yyPreviousStart = yyStartState; yyStartState = State; }
# define yyPrevious	{ yyStateRange s = yyStartState; \
	 		yyStartState = yyPreviousStart; yyPreviousStart = s; }
# define yyEcho		{ char * yyEnd = TokenPtr + TokenLength; \
			char yyCh = * yyEnd; * yyEnd = '\0'; \
	 		(void) fputs (TokenPtr, stdout); * yyEnd = yyCh; }
# define yyLess(n)	{ yyChBufferIndex -= TokenLength - n; TokenLength = n; }
# define yyTab		yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart - 1) % yyTabSpace
# define yyTab1(a)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyTab2(a,b)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyEol(Column)	{ yyLineCount ++; yyLineStart = yyChBufferIndex - 1 - Column; }
# define output(c)	(void) putchar ((int) c)
# define unput(c)	* (-- yyChBufferIndex) = c

# define yyDNoState		0
# define yyFileStackSize	16
# define yyInitBufferSize	1024 * 8 + 256
# define yyFirstCh	(unsigned char) '\0'
# define yyLastCh	(unsigned char) '\177'
# define yyEolCh	(unsigned char) '\12'
# define yyEobCh	(unsigned char) '\177'
# define yyDStateCount	129
# define yyTableSize	632
# define yyEobState	15
# define yyDefaultState	16
# define STD	1
# define QUOTE	3
# define AQUOTE	5
 
static void yyExit () { Exit (1); }

typedef unsigned short	yyStateRange;
typedef struct { yyStateRange yyCheck, yyNext; } yyCombType;
 
	char *		TokenPtr	;
	short		TokenLength	;
	tScanAttribute	Attribute	;
	void		(* Scanner_Exit) () = yyExit;
 
static	yyCombType	yyComb		[yyTableSize   + 1] = {{1, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{1, 11},
{3, 129},
{8, 10},
{0, 0},
{0, 0},
{0, 0},
{13, 9},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{87, 88},
{58, 59},
{89, 90},
{91, 92},
{34, 35},
{0, 0},
{5, 18},
{5, 17},
{21, 22},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{23, 24},
{24, 25},
{28, 29},
{30, 31},
{29, 30},
{40, 41},
{41, 42},
{44, 45},
{1, 23},
{3, 23},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{25, 26},
{5, 19},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{7, 12},
{0, 0},
{34, 35},
{5, 109},
{5, 108},
{0, 0},
{21, 22},
{5, 51},
{5, 13},
{5, 107},
{5, 91},
{23, 24},
{24, 25},
{28, 29},
{30, 31},
{29, 30},
{40, 41},
{41, 42},
{44, 45},
{1, 23},
{3, 23},
{5, 43},
{5, 50},
{5, 89},
{5, 58},
{5, 87},
{25, 26},
{5, 70},
{5, 32},
{5, 7},
{5, 44},
{5, 7},
{5, 20},
{5, 7},
{5, 7},
{5, 7},
{5, 105},
{5, 7},
{5, 7},
{5, 7},
{5, 7},
{5, 52},
{5, 66},
{5, 7},
{5, 7},
{5, 124},
{5, 111},
{5, 7},
{5, 79},
{5, 7},
{5, 77},
{5, 60},
{5, 7},
{5, 7},
{5, 80},
{14, 15},
{5, 78},
{0, 0},
{0, 0},
{0, 0},
{5, 32},
{5, 7},
{5, 44},
{5, 7},
{5, 20},
{5, 7},
{5, 7},
{5, 7},
{5, 105},
{5, 7},
{5, 7},
{5, 7},
{5, 7},
{5, 52},
{5, 66},
{5, 7},
{5, 7},
{5, 124},
{5, 111},
{5, 7},
{5, 79},
{5, 7},
{5, 77},
{5, 60},
{5, 7},
{5, 7},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{0, 0},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{0, 0},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{11, 8},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{0, 0},
{26, 27},
{27, 28},
{33, 34},
{35, 36},
{36, 37},
{38, 39},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{26, 27},
{27, 28},
{33, 34},
{35, 36},
{36, 37},
{38, 39},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{12, 7},
{20, 84},
{20, 82},
{32, 94},
{39, 40},
{45, 46},
{46, 47},
{32, 83},
{32, 81},
{20, 21},
{47, 48},
{48, 49},
{52, 55},
{32, 33},
{53, 54},
{32, 68},
{53, 93},
{55, 56},
{56, 57},
{20, 86},
{32, 38},
{60, 61},
{60, 64},
{61, 62},
{62, 63},
{32, 85},
{52, 53},
{64, 65},
{0, 0},
{68, 69},
{70, 71},
{71, 72},
{72, 73},
{20, 84},
{20, 82},
{32, 94},
{39, 40},
{45, 46},
{46, 47},
{32, 83},
{32, 81},
{20, 21},
{47, 48},
{48, 49},
{52, 55},
{32, 33},
{53, 54},
{32, 68},
{53, 93},
{55, 56},
{56, 57},
{20, 86},
{32, 38},
{60, 61},
{60, 64},
{61, 62},
{62, 63},
{32, 85},
{52, 53},
{64, 65},
{66, 110},
{68, 69},
{70, 71},
{71, 72},
{72, 73},
{73, 74},
{74, 75},
{75, 76},
{94, 95},
{95, 96},
{96, 97},
{97, 98},
{66, 67},
{98, 99},
{99, 100},
{100, 101},
{101, 102},
{102, 103},
{103, 104},
{105, 106},
{111, 112},
{112, 113},
{113, 114},
{114, 115},
{115, 116},
{116, 117},
{117, 118},
{118, 119},
{119, 120},
{120, 121},
{121, 122},
{122, 123},
{66, 110},
{124, 125},
{125, 126},
{126, 127},
{127, 128},
{73, 74},
{74, 75},
{75, 76},
{94, 95},
{95, 96},
{96, 97},
{97, 98},
{66, 67},
{98, 99},
{99, 100},
{100, 101},
{101, 102},
{102, 103},
{103, 104},
{105, 106},
{111, 112},
{112, 113},
{113, 114},
{114, 115},
{115, 116},
{116, 117},
{117, 118},
{118, 119},
{119, 120},
{120, 121},
{121, 122},
{122, 123},
{0, 0},
{124, 125},
{125, 126},
{126, 127},
{127, 128},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
};
static	yyCombType *	yyBasePtr	[yyDStateCount + 1] = {& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [1],
& yyComb [0],
& yyComb [58],
& yyComb [0],
& yyComb [0],
& yyComb [2],
& yyComb [181],
& yyComb [0],
& yyComb [276],
& yyComb [355],
& yyComb [0],
& yyComb [23],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [408],
& yyComb [1],
& yyComb [0],
& yyComb [5],
& yyComb [8],
& yyComb [4],
& yyComb [332],
& yyComb [333],
& yyComb [3],
& yyComb [0],
& yyComb [6],
& yyComb [0],
& yyComb [414],
& yyComb [329],
& yyComb [0],
& yyComb [328],
& yyComb [335],
& yyComb [0],
& yyComb [336],
& yyComb [396],
& yyComb [2],
& yyComb [11],
& yyComb [0],
& yyComb [0],
& yyComb [2],
& yyComb [405],
& yyComb [406],
& yyComb [414],
& yyComb [404],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [424],
& yyComb [409],
& yyComb [0],
& yyComb [416],
& yyComb [427],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [420],
& yyComb [421],
& yyComb [419],
& yyComb [0],
& yyComb [422],
& yyComb [0],
& yyComb [467],
& yyComb [0],
& yyComb [438],
& yyComb [0],
& yyComb [424],
& yyComb [424],
& yyComb [444],
& yyComb [476],
& yyComb [467],
& yyComb [475],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [2],
& yyComb [0],
& yyComb [3],
& yyComb [0],
& yyComb [0],
& yyComb [479],
& yyComb [464],
& yyComb [478],
& yyComb [462],
& yyComb [477],
& yyComb [486],
& yyComb [468],
& yyComb [480],
& yyComb [475],
& yyComb [477],
& yyComb [0],
& yyComb [473],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [477],
& yyComb [489],
& yyComb [492],
& yyComb [487],
& yyComb [491],
& yyComb [489],
& yyComb [496],
& yyComb [499],
& yyComb [481],
& yyComb [493],
& yyComb [488],
& yyComb [490],
& yyComb [0],
& yyComb [505],
& yyComb [493],
& yyComb [501],
& yyComb [504],
& yyComb [0],
& yyComb [0],
};
static	yyStateRange	yyDefault	[yyDStateCount + 1] = {0,
5,
1,
5,
3,
14,
5,
12,
14,
13,
0,
14,
14,
14,
0,
0,
0,
0,
0,
0,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
0,
7,
7,
7,
7,
7,
7,
0,
0,
7,
7,
7,
7,
7,
7,
14,
0,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
14,
14,
14,
14,
14,
14,
0,
7,
0,
7,
0,
7,
7,
7,
7,
7,
7,
14,
0,
14,
0,
14,
0,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
0,
0,
0,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
7,
23,
7,
7,
7,
7,
0,
};
static	yyStateRange	yyEobTrans	[yyDStateCount + 1] = {0,
0,
0,
0,
0,
0,
0,
0,
0,
9,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
};

static	yyStateRange	yyInitStateStack [yyInitBufferSize] = {0};
static	yyStateRange *	yyStateStack	= yyInitStateStack;
static	unsigned long	yyStateStackSize= yyInitBufferSize;
static	yyStateRange	yyStartState	= 0;
static	yyStateRange	yyPreviousStart	= 1;

static  short		yySourceFile	;
static	bool		yyEof		;
static	unsigned char *	yyChBufferPtr	;
static	unsigned char *	yyChBufferStart	;
static	unsigned long	yyChBufferSize	;
static	unsigned char *	yyChBufferIndex	= ((unsigned char *) yyComb) + 2; /* dirty trick */
static	int		yyBytesRead	;
static	int		yyLineCount	;
static	unsigned char *	yyLineStart	;

static	struct {
	short		yySourceFile	;
	bool		yyEof		;
	unsigned char *	yyChBufferPtr	;
	unsigned char *	yyChBufferStart	;
	unsigned long	yyChBufferSize	;
	unsigned char *	yyChBufferIndex	;
	int		yyBytesRead	;
	int		yyLineCount	;
	unsigned char *	yyLineStart	;
	} yyFileStack [yyFileStackSize + 1], * yyFileStackPtr = yyFileStack;

static	unsigned char	yyToLower	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '[', '\\', ']', '^', '_',
'`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};

static	unsigned char	yyToUpper	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_',
'`', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};
 
static	void	yyInitialize	();
static	void	yyErrorMessage	ARGS((int yyErrorCode));
static	char	input		();
/* line 26 "spec.rex" */


void ErrorAttribute
# if defined __STDC__ | defined __cplusplus
 (int Token, tScanAttribute * pAttribute)
# else
 (Token, pAttribute) int Token; tScanAttribute * pAttribute;
# endif
{
 pAttribute->Position = Attribute.Position;
 switch (Token) {
 case /* identifier */ 1: 
  pAttribute->identifier.Id = (char *) NULL;
  ;
 break;
 case /* character_literal */ 2: 
 pAttribute->character_literal.Val = '\0';
 ;
 break;
 }
}



 
int GetToken ()
{
   register	yyStateRange	yyState;
   register	yyStateRange *	yyStatePtr;
   register	unsigned char * yyChBufferIndexReg;
   register	yyCombType * *	yyBasePtrReg = yyBasePtr;
   
yyBegin:
   yyState		= yyStartState;		/* initialize */
   yyStatePtr		= & yyStateStack [1];
   yyChBufferIndexReg 	= yyChBufferIndex;
   TokenPtr	 	= (char *) yyChBufferIndexReg;
 
   /* ASSERT yyChBuffer [yyChBufferIndex] == first character */
 
yyContinue:		/* continue after sentinel or skipping blanks */
   for (;;) {		/* execute as many state transitions as possible */
					/* determine next state and get next character */
      register yyCombType * yyTablePtr = (yyBasePtrReg [yyState] + * yyChBufferIndexReg ++);
      if (yyTablePtr->yyCheck == yyState) {
	 yyState = yyTablePtr->yyNext;
	 * yyStatePtr ++ = yyState;		/* push state */
	 goto yyContinue;
      }
      yyChBufferIndexReg --;			/* reconsider character */
      if ((yyState = yyDefault [yyState]) == yyDNoState) break;
   }
 
   for (;;) {					/* search for last final state */
      TokenLength = yyChBufferIndexReg - (unsigned char *) TokenPtr;
      yyChBufferIndex = yyChBufferIndexReg;
switch (* -- yyStatePtr) {
case 10:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 73 "spec.rex" */
{ Attribute.character_literal.Val = TokenPtr[1];
	  return 2; 
} yy1: goto yyBegin;
case 9:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 76 "spec.rex" */
{
} yy2: goto yyBegin;
case 108:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 78 "spec.rex" */
{ yyStart(QUOTE); return 6; 
} yy3: goto yyBegin;
case 129:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 79 "spec.rex" */
{ yyStart(AQUOTE); return "'"; 
} yy4: goto yyBegin;
case 128:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 82 "spec.rex" */
{ yyStart(QUOTE);
          Attribute.identifier.Id = StrnDupLwr(TokenPtr, TokenLength);
          return 1; 
} yy5: goto yyBegin;
case 123:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 86 "spec.rex" */
{  yyStart (STD); return 3; 
} yy6: goto yyBegin;
case 110:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 87 "spec.rex" */
{  yyStart (STD); return 4; 
} yy7: goto yyBegin;
case 109:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 88 "spec.rex" */
{  yyStart (STD); return 5; 
} yy8: goto yyBegin;
case 107:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 90 "spec.rex" */
{  yyStart (STD); return 7; 
} yy9: goto yyBegin;
case 106:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 91 "spec.rex" */
{  yyStart (STD); return 8; 
} yy10: goto yyBegin;
case 104:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 92 "spec.rex" */
{  yyStart (STD); return 9; 
} yy11: goto yyBegin;
case 93:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 93 "spec.rex" */
{  yyStart (STD); return 10; 
} yy12: goto yyBegin;
case 58:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 94 "spec.rex" */
{  yyStart (STD); return 11; 
} yy13: goto yyBegin;
case 92:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 95 "spec.rex" */
{  yyStart (STD); return 12; 
} yy14: goto yyBegin;
case 89:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 96 "spec.rex" */
{  yyStart (STD); return 13; 
} yy15: goto yyBegin;
case 90:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 97 "spec.rex" */
{  yyStart (STD); return 14; 
} yy16: goto yyBegin;
case 87:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 98 "spec.rex" */
{  yyStart (STD); return 15; 
} yy17: goto yyBegin;
case 88:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 99 "spec.rex" */
{  yyStart (STD); return 16; 
} yy18: goto yyBegin;
case 86:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 100 "spec.rex" */
{  yyStart (STD); return 17; 
} yy19: goto yyBegin;
case 85:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 101 "spec.rex" */
{  yyStart (STD); return 18; 
} yy20: goto yyBegin;
case 84:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 102 "spec.rex" */
{  yyStart (STD); return 19; 
} yy21: goto yyBegin;
case 83:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 103 "spec.rex" */
{  yyStart (STD); return 20; 
} yy22: goto yyBegin;
case 82:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 104 "spec.rex" */
{  yyStart (STD); return 21; 
} yy23: goto yyBegin;
case 81:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 105 "spec.rex" */
{  yyStart (STD); return 22; 
} yy24: goto yyBegin;
case 20:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 106 "spec.rex" */
{  yyStart (STD); return 23; 
} yy25: goto yyBegin;
case 80:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 107 "spec.rex" */
{  yyStart (STD); return 24; 
} yy26: goto yyBegin;
case 79:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 108 "spec.rex" */
{  yyStart (STD); return 25; 
} yy27: goto yyBegin;
case 78:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 109 "spec.rex" */
{  yyStart (STD); return 26; 
} yy28: goto yyBegin;
case 77:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 110 "spec.rex" */
{  yyStart (STD); return 27; 
} yy29: goto yyBegin;
case 32:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 111 "spec.rex" */
{  yyStart (STD); return 28; 
} yy30: goto yyBegin;
case 76:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 112 "spec.rex" */
{  yyStart (STD); return 29; 
} yy31: goto yyBegin;
case 69:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 113 "spec.rex" */
{  yyStart (STD); return 30; 
} yy32: goto yyBegin;
case 67:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 114 "spec.rex" */
{  yyStart (STD); return 31; 
} yy33: goto yyBegin;
case 65:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 115 "spec.rex" */
{  yyStart (STD); return 32; 
} yy34: goto yyBegin;
case 63:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 116 "spec.rex" */
{  yyStart (STD); return 33; 
} yy35: goto yyBegin;
case 59:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 117 "spec.rex" */
{  yyStart (STD); return 34; 
} yy36: goto yyBegin;
case 57:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 118 "spec.rex" */
{  yyStart (STD); return 35; 
} yy37: goto yyBegin;
case 54:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 119 "spec.rex" */
{  yyStart (STD); return 36; 
} yy38: goto yyBegin;
case 51:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 120 "spec.rex" */
{  yyStart (STD); return 37; 
} yy39: goto yyBegin;
case 50:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 121 "spec.rex" */
{  yyStart (STD); return 38; 
} yy40: goto yyBegin;
case 49:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 122 "spec.rex" */
{  yyStart (STD); return 39; 
} yy41: goto yyBegin;
case 43:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 123 "spec.rex" */
{  yyStart (STD); return 40; 
} yy42: goto yyBegin;
case 42:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 124 "spec.rex" */
{  yyStart (STD); return 41; 
} yy43: goto yyBegin;
case 37:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 125 "spec.rex" */
{  yyStart (STD); return 42; 
} yy44: goto yyBegin;
case 31:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 126 "spec.rex" */
{  yyStart (STD); return 43; 
} yy45: goto yyBegin;
case 22:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 127 "spec.rex" */
{  yyStart (STD); return 44; 
} yy46: goto yyBegin;
case 7:;
case 21:;
case 23:;
case 24:;
case 25:;
case 26:;
case 27:;
case 28:;
case 29:;
case 30:;
case 33:;
case 34:;
case 35:;
case 36:;
case 38:;
case 39:;
case 40:;
case 41:;
case 44:;
case 45:;
case 46:;
case 47:;
case 48:;
case 52:;
case 53:;
case 55:;
case 56:;
case 60:;
case 61:;
case 62:;
case 64:;
case 66:;
case 68:;
case 94:;
case 95:;
case 96:;
case 97:;
case 98:;
case 99:;
case 100:;
case 101:;
case 102:;
case 103:;
case 105:;
case 111:;
case 112:;
case 113:;
case 114:;
case 115:;
case 116:;
case 117:;
case 118:;
case 119:;
case 120:;
case 121:;
case 122:;
case 124:;
case 125:;
case 126:;
case 127:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 131 "spec.rex" */
{ yyStart(QUOTE);
          Attribute.identifier.Id = StrnDupLwr(TokenPtr, TokenLength);
          return 1; 
} yy47: goto yyBegin;
case 19:;
{/* BlankAction */
while (* yyChBufferIndexReg ++ == ' ') ;
TokenPtr = (char *) -- yyChBufferIndexReg;
yyState = yyStartState;
yyStatePtr = & yyStateStack [1];
goto yyContinue;
} yy48: goto yyBegin;
case 18:;
{/* TabAction */
yyLineStart -= 7 - ((unsigned char *) TokenPtr - yyLineStart - 1) & 0x7; /* % 8 */
} yy49: goto yyBegin;
case 17:;
{/* EolAction */
yyLineCount ++;
yyLineStart = yyChBufferIndexReg - 1;
} yy50: goto yyBegin;
case 1:;
case 2:;
case 3:;
case 4:;
case 5:;
case 6:;
case 8:;
case 11:;
case 12:;
case 13:;
case 14:;
case 70:;
case 71:;
case 72:;
case 73:;
case 74:;
case 75:;
case 91:;
	 /* non final states */
	 yyChBufferIndexReg --;			/* return character */
	 break;
 
case 16:
	 Attribute.Position.Line   = yyLineCount;
	 Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
      /* TokenLength   = 1; */
	 yyChBufferIndex = ++ yyChBufferIndexReg;
	 {
/* line 51 "spec.rex" */
 

MessageI ("illegal character", xxError, Attribute.Position, xxCharacter, 
		TokenPtr);

	 }
	 goto yyBegin;
 
      case yyDNoState:				/* automatic initialization */
	 yyInitialize ();
	 yySourceFile = StdIn;
	 goto yyBegin;

case 15:
	 yyChBufferIndex = -- yyChBufferIndexReg; /* undo last state transition */
	 if (-- TokenLength == 0) {		/* get previous state */
	    yyState = yyStartState;
	 } else {
	    yyState = * (yyStatePtr - 1);
	 }

	 if (yyChBufferIndex != & yyChBufferStart [yyBytesRead]) {
						/* end of buffer sentinel in buffer */
	    if ((yyState = yyEobTrans [yyState]) == yyDNoState) continue;
	    yyChBufferIndexReg ++;
	    * yyStatePtr ++ = yyState;		/* push state */
	    goto yyContinue;
	 }
						/* end of buffer reached */
	 {  /* copy initial part of token in front of the input buffer */
	    register char * yySource = TokenPtr;
	    register char * yyTarget = TokenPtr = (char *) & yyChBufferPtr [yyMaxAlign - TokenLength % yyMaxAlign];
	    if (yySource != yyTarget) {
	       while (yySource < (char *) yyChBufferIndexReg) * yyTarget ++ = * yySource ++;
	       yyLineStart += (unsigned char *) yyTarget - yyChBufferStart - yyBytesRead;
	       yyChBufferStart = (unsigned char *) yyTarget;
	    } else {
	       yyChBufferStart = yyChBufferIndexReg;
	    }
	 }

	 if (! yyEof) {				/* read buffer and restart */
	    int yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - TokenLength));
	    if (yyChBufferFree < yyChBufferSize / 8) {
	       register int yyDelta;
	       register unsigned char * yyOldChBufferPtr = yyChBufferPtr;
	       ExtendArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
	       if (yyChBufferPtr == NULL) yyErrorMessage (1);
	       yyDelta = yyChBufferPtr - yyOldChBufferPtr;
	       yyChBufferStart	+= yyDelta;
	       yyLineStart	+= yyDelta;
	       TokenPtr	+= yyDelta;
	       yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - TokenLength));
	       if (yyStateStackSize < yyChBufferSize) {
		  yyStateRange * yyOldStateStack = yyStateStack;
		  ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
		  if (yyStateStack == NULL) yyErrorMessage (1);
		  yyStatePtr	+= yyStateStack - yyOldStateStack;
	       }
	    }
	    yyChBufferIndex = yyChBufferIndexReg = yyChBufferStart;
	    yyBytesRead = GetLine (yySourceFile, (char *) yyChBufferIndex, yyChBufferFree);
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	    goto yyContinue;
	 }

	 if (TokenLength == 0) {		/* end of file reached */
	    Attribute.Position.Line   = yyLineCount;
	    Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
	    CloseFile ();
	    if (yyFileStackPtr == yyFileStack) {
	    }
	    if (yyFileStackPtr == yyFileStack) return EofToken;
	    goto yyBegin;
	 }
	 break;
 
      default:
	 yyErrorMessage (0);
      }
   }
}
 
void BeginFile
# if defined __STDC__ | defined __cplusplus
   (char * yyFileName)
# else
   (yyFileName) char * yyFileName;
# endif
   {
      yyInitialize ();
      yySourceFile = BeginSource (yyFileName);
   }

static void yyInitialize ()
   {
      if (yyFileStackPtr >= yyFileStack + yyFileStackSize) yyErrorMessage (2);
      yyFileStackPtr ++;			/* push file */
      yyFileStackPtr->yySourceFile	= yySourceFile		;
      yyFileStackPtr->yyEof		= yyEof			;
      yyFileStackPtr->yyChBufferPtr	= yyChBufferPtr		;
      yyFileStackPtr->yyChBufferStart	= yyChBufferStart	;
      yyFileStackPtr->yyChBufferSize	= yyChBufferSize	;
      yyFileStackPtr->yyChBufferIndex	= yyChBufferIndex	;
      yyFileStackPtr->yyBytesRead	= yyBytesRead		;
      yyFileStackPtr->yyLineCount	= yyLineCount		;
      yyFileStackPtr->yyLineStart	= yyLineStart		;
						/* initialize file state */
      yyChBufferSize	   = yyInitBufferSize;
      MakeArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
      if (yyChBufferPtr == NULL) yyErrorMessage (1);
      yyChBufferStart	   = & yyChBufferPtr [yyMaxAlign];
      yyChBufferStart [-1] = yyEolCh;		/* begin of line indicator */
      yyChBufferStart [ 0] = yyEobCh;		/* end of buffer sentinel */
      yyChBufferStart [ 1] = '\0';
      yyChBufferIndex	   = yyChBufferStart;
      yyEof		   = false;
      yyBytesRead	   = 0;
      yyLineCount	   = 1;
      yyLineStart	   = & yyChBufferStart [-1];
      if (yyStartState == 0) {
	 yyStartState	   = STD;
	 yyStateStack [0]  = yyDefaultState;	/* stack underflow sentinel */
      }
   }

void CloseFile ()
   {
      if (yyFileStackPtr == yyFileStack) yyErrorMessage (3);
      CloseSource (yySourceFile);
      ReleaseArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
						/* pop file */
      yySourceFile	= yyFileStackPtr->yySourceFile		;
      yyEof		= yyFileStackPtr->yyEof			;
      yyChBufferPtr	= yyFileStackPtr->yyChBufferPtr		;
      yyChBufferStart	= yyFileStackPtr->yyChBufferStart	;
      yyChBufferSize	= yyFileStackPtr->yyChBufferSize	;
      yyChBufferIndex	= yyFileStackPtr->yyChBufferIndex	;
      yyBytesRead	= yyFileStackPtr->yyBytesRead		;
      yyLineCount	= yyFileStackPtr->yyLineCount		;
      yyLineStart	= yyFileStackPtr->yyLineStart		;
      yyFileStackPtr --;		
   }
 
int GetWord
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = * yySource ++;
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
int GetLower
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToLower [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
int GetUpper
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToUpper [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
static char input ()
   {
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) {
	 if (! yyEof) {
	    yyLineStart -= yyBytesRead;
	    yyChBufferIndex = yyChBufferStart = yyChBufferPtr;
	    yyBytesRead = GetLine (yySourceFile, (char *) yyChBufferIndex,
	       (int) Exp2 (Log2 (yyChBufferSize)));
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	 }
      }
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) return '\0';
      else return * yyChBufferIndex ++;
   }

void BeginScanner ()
   {
   }
 
void CloseScanner ()
   {
   }
 
static void yyErrorMessage
# if defined __STDC__ | defined __cplusplus
   (int yyErrorCode)
# else
   (yyErrorCode) int yyErrorCode;
# endif
   {
      WritePosition (stderr, Attribute.Position);
      switch (yyErrorCode) {
      case 0: (void) fprintf (stderr, ": Scanner: internal error\n"); break;
      case 1: (void) fprintf (stderr, ": Scanner: out of memory\n"); break;
      case 2: (void) fprintf (stderr, ": Scanner: too many nested include files\n"); break;
      case 3: (void) fprintf (stderr, ": Scanner: file stack underflow (too many calls of CloseFile)\n"); break;
      }
      Scanner_Exit ();
   }
