/** CHeaderFile ********************************************************

  FileName    [ img.h ]

  PackageName [ img ]

  Synopsis    [ Required ]

  Description [ Optional ]

  SeeAlso     [ Optional ]

  Author      [ David Deharbe. ]

  Copyright   [ Copyright (c) 1996, Carnegie Mellon University.
                All rights reserved. ]

  Revision    [ 3 ]

***********************************************************************/
#ifndef _IMGH
#define _IMGH

#   include <stdio.h>
#   include <vbdd.h>

/*--------------------------------------------------------------------*/
/* Constant declarations                                              */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/* Type declarations                                                  */
/*--------------------------------------------------------------------*/
typedef struct img_manager_rec_ * img_manager ;

/*--------------------------------------------------------------------*/
/* Structure declarations                                             */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/* Variable declarations                                              */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/* Macro declarations                                                 */
/*--------------------------------------------------------------------*/

/**AutomaticStart******************************************************/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/

extern img_manager img_New(bdd_manager bddm, vbdd variables, vbdd functions);
extern void img_Free(img_manager transition);
extern char * img_Version(void);
extern long img_Size(img_manager t);
extern void img_Flush(img_manager t);
extern bdd img_Compute(img_manager t, bdd set);
extern bdd img_ComputeReachableStates(img_manager t, bdd init);
extern void img_ReduceCareSet(img_manager t, bdd care);
extern void img_ReduceSCC(img_manager t, bdd init);

/**AutomaticEnd********************************************************/

#endif /* _IMGH */
